﻿using Prism.Commands;
using Prism.Ioc;
using Prism.Mvvm;
using Prism.Regions;
using System.Windows.Controls;

namespace BuildProcess.ViewModels
{
    public class MainWindowViewModel : BindableBase
    {
        private string _title = "Prism Application";

        private IContainerProvider _container;


        private DelegateCommand<Canvas> _LoadCommand;

        public DelegateCommand<Canvas> LoadCommand => _LoadCommand ?? ( _LoadCommand = new DelegateCommand<Canvas>(OnLoad) );


        public string Title
        {
            get { return _title; }
            set { SetProperty(ref _title, value); }
        }

        public MainWindowViewModel(IContainerProvider container)
        {
            _container = container;
            var regionManager = _container.Resolve<RegionManager>();
            //regionManager.Regions[ "EditRegion" ].RequestNavigate("");
        }

        public void OnLoad(Canvas canvas)
        {
            Element   element=new Element("TcpClient",_container);
            //element.parentClass = _container.Resolve<TcpClientModule.Service>();
            element._Name = "TcpClient";
            element.SourcesName = "TcpClientView";
            Canvas.SetTop(element.rect, 10);
            canvas.Children.Add(element.rect);



            element = new Element("TcpClientSend", _container);
            //element._iModule = _container.Resolve<TcpServerModule.Service>();
            element._Name = "TcpClientSend";
            element.SourcesName = "TcpClientSendView";
            Canvas.SetTop(element.rect, element.rect.Height + 10);
            canvas.Children.Add(element.rect);

            element = new Element("TcpClientRcv", _container);
            //element._iModule = _container.Resolve<TcpServerModule.Service>();
            element._Name = "TcpClientRcv";
            element.SourcesName = "TcpClientRcvView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);

            element = new Element("TcpServer", _container);
            //element._iModule = _container.Resolve<TcpServerModule.Service>();
            element._Name = "TcpServer";
            element.SourcesName = "TcpServer";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);



            element = new Element("TcpModbusMaster", _container);
            //element._iModule = _container.Resolve<TcpModbusMasterModule.Service>();
            element._Name = "TcpModbusMaster";
            element.SourcesName = "TcpModbusMaster";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);


            element = new Element("TcpModbusSlave", _container);
            //element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();
            element._Name = "TcpModbusSlave";
            element.SourcesName = "TcpModbusSlave";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);


            element = new Element("TcpModbusSlave", _container);
            //element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();
            element._Name = "TcpModbusSlave";
            element.SourcesName = "TcpModbusSlave";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;

            element = new Element("Plc_S7", _container);
            // element._iModule = _container.Resolve<TcpModbusSlaveModule.Service>();

            element._Name = "Plc_S7";
            element.SourcesName = "S7NetView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;

            element = new Element("S7_读", _container);
            element.parentClass = _container.Resolve<ReadService>();
            element._Name = "S7_读";
            element.SourcesName = "S7ReadlView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;






            element = new Element("S7_写", _container);
            element.parentClass = _container.Resolve<WriteService>();
            element._Name = "S7_写";
            element.SourcesName = "S7WriteView";
            Canvas.SetTop(element.rect, element.rect.Height * canvas.Children.Count + 10);
            canvas.Children.Add(element.rect);
            canvas.Height = 0;
            canvas.Height += element.rect.Height * canvas.Children.Count + 10 * canvas.Children.Count + 30;




        }
    }
}
